% 1-vs-all L2-svm loss function;  similar to LibLinear.
function [loss, g] = my_l2svmloss(w, X, y, K, C)
    [M,N] = size(X);
    theta = reshape(w, N,K);
    Y = bsxfun(@(y,ypos) 2*(y==ypos)-1, y, 1:K);
    
    margin = max(0, 1 - Y .* (X*theta));
    loss = (0.5 * sum(theta.^2)) + C*mean(margin.^2);
    loss = sum(loss);
    g = theta - 2*C/M * (X' * (margin .* Y));
    g = g(:);
    
    [v,i] = max(X*theta,[],2);
    sum(i ~= y) / length(y);
    loss = double(loss);
    g = double(g);